using System;
using System.ComponentModel;
using System.Threading;
using System.Net.Sockets;
using System.Windows.Forms;
using System.IO;
public class ATMClient {
  ///<summary>
  /// The ATMClient Program          Bishop and Horspool   Feb 2003
  /// =====================
  /// Allows communication by connecting to an ATM Server.
  /// Illustrates network communication.
  ///</summary>
  private NetworkStream output;
  private BinaryWriter writer;
  private BinaryReader reader;
  private string message = "";
  private Thread readThread;
  Views.Form view;
  static int port = 8190;

  ATMClient() {
    try {
      view = new Views.Form(@"<Form Text = 'Client'>
        <vertical>
          <Label Text='Welcome to Savanna bank!' halign=center
                     Font=bold12/>
          <ListBox Name='Out' Width='300' Height='200' Font=sans10
                     BackColor=BlanchedAlmond/>
          <horizontal>
             <TextBox Name='In' Text='' Width='100' Font=Courier10
                     BackColor=LightBlue/>
             <Button Name=Submit Width=85 Font=monospacebold/>
          </horizontal>
        </vertical>
      </form>");
      
      readThread = new Thread(new ThreadStart(Connect));
      readThread.Start();
      GUICommunication();
    } catch(Exception e) {
      Console.WriteLine(e.Message);
    }
  }

  void Connect() {
    TcpClient client;
    view.PutText("Out", "Attempting connection...");
    client = new TcpClient();
    client.Connect("localhost", port);
    output = client.GetStream();
    writer = new BinaryWriter(output);
    reader = new BinaryReader(output);
    do {
      try {
        message = reader.ReadString();
        view.PutText("Out", message);
      }  catch(Exception error)      {
        Console.WriteLine(error.ToString());
      }
    } while (message != "Simulation complete. Thanks.");
    reader.Close();
    writer.Close();
    output.Close();
  }

  void GUICommunication() {
    while(view != null) {
      string b = view.GetControl(); 
      switch(b) {
        case "Submit":
          writer.Write(view.GetText("In") + "\n");
          view.PutText("In", "");
          break; 
      }
    }
    view.CloseGUI();
  }

  static void Main(string[] args) {
    if (args.Length > 0)
      port = int.Parse(args[0]);
    new ATMClient();
  }
}
