using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Imaging;

class FetchImagewithBox : Form {
  
  ///<summary>
  /// Drawing on an image with a box    Bishop and Horspool March 2003
  /// ==============================
  /// Allows a fixed box to be drawn on an image in a picture box
  /// Shows the paint event handling
  ///</summary>

  public FetchImagewithBox() {
    this.Width=1000;
    this.Height=800;
    this.Text="Fetch Image with Box";

    // Get the image and assign it to a PictureBox
    PictureBox picture = new PictureBox();
    picture.Image = Image.FromFile("Jacarandas.jpg");
    picture.SizeMode = PictureBoxSizeMode.AutoSize;
    picture.Location = new Point(50,50);

    // Add the picture to the controls for this program (object)
    this.Controls.Add(picture);

    // Link the specified method up to the picture's Paint event
    picture.Paint += new PaintEventHandler(FetchImagePaint);
  }

  // When the form associated with program appears, its controls are
  // drawn, including picture, and picture's designated paint event 
  // is called
  void FetchImagePaint (Object source, PaintEventArgs e) {
    Graphics g = e.Graphics;
    Pen pen = new Pen(new SolidBrush(Color.Black),10);
    g.DrawRectangle(pen,150,200,100,100);
  }

  static void Main() {
    Application.Run(new FetchImagewithBox());
  }
}
